C @@ 016144909 /clear_vobs1/MODIS/STORE/PGE11/MOD_PR09/atmos.f /main/1 Jennifer Davis (STX) 08-Jan-98.12:51:44 @@
        SUBROUTINE CHAND(XPHI,XMUV,XMUS,XTAU,XRRAY,newflag,exp1,exp2)
        IMPLICIT NONE
C---------------------------------------------------------------------
C !F77
C
C !DESCRIPTION:
C
C !INPUT PARAMETERS:
C      XPHI: AZIMUTHAL DIFFERENCE BETWEEN SUN AND OBSERVATION
C            (XPHI=0,IN BACKSCATTERING) AND EXPRESSED IN DEGREE (0.:360.)
C      XMUS: COSINE OF THE SUN ZENITH ANGLE
C      XMUV: COSINE OF THE OBSERVATION ZENITH ANGLE
C      XTAU: MOLECULAR OPTICAL DEPTH
C      newflag: 0 = arguments XPHI, XMUS, XMUV have the same values
C               they did the previous time this subroutine was called
C
C !OUTPUT PARAMETERS:
C      XRRAY : MOLECULAR REFLECTANCE (0.:1.)
C      exp1
C      exp2
C
C !REVISION HISTORY:
C $Log: atmos.f,v $
C Revision 1.2  1996/10/24 17:22:37  fisher
C SDST baselined Version 1
C Returned from SDST 10/23/96
C
C
C !REFERENCES AND CREDITS:
C
C !DESIGN NOTES:
C  Constants   : XDEP: DEPOLARIZATION FACTOR (0.0279)
C
C !END
C--------------------------------------------------------------------- 

        REAL    XPHI,XMUV,XMUS,XTAU,XRRAY
        integer newflag
        real    exp1, exp2
        INTEGER I
        REAL FAC,PHIOS,XCOSF1,XCOSF2,XCOSF3,XBETA2
        REAL XFD,XPH1,XPH2,XPH3,XITM,XP1,XP2,XP3,CFONC1,CFONC2,CFONC3
        REAL XLNTAU,XITOT1,XITOT2,XITOT3
        REAL XDEP,PL(10)
        REAL FS0,FS1,FS2

        real    xmus2, xmuv2            ! squares of XMUS, XMUV

        parameter (FAC = 0.017453293)   ! one over pi
        parameter (XDEP = 0.0279)       ! depolarization factor

        parameter (XBETA2 = 0.5)        ! ?

        save    PHIOS, XCOSF1, XCOSF2, XCOSF3
        save    xfd, xmus2, xmuv2, XPH1, XPH2, XPH3

        REAL AS0(10),AS1(2),AS2(2)
        DATA (AS0(I),I=1,10) /.33243832,-6.777104E-02,.16285370
     &  ,1.577425E-03,-0.30924818,-1.240906E-02,-0.10324388
     &  ,3.241678E-02,.11493334,-3.503695E-02/
        DATA (AS1(I),I=1,2) /.19666292, -5.439061E-02/
        DATA (AS2(I),I=1,2) /.14545937,-2.910845E-02/

        ! Recompute some values only if they have changed since the
        ! last time this subroutine was called.
        if (newflag .NE. 0) then
                PHIOS = 180.0 - XPHI
                XCOSF1 = 1.0
                XCOSF2=COS(PHIOS*FAC)
                XCOSF3=COS(2*PHIOS*FAC)

                XFD=XDEP/(2-XDEP)
                XFD=(1-XFD)/(1+2*XFD)
                xmus2 = XMUS * XMUS
                xmuv2 = XMUV * XMUV
                XPH1=1+(3*xmus2-1)*(3*xmuv2-1)*XFD*0.125
                XPH2=-XMUS*XMUV*SQRT(1-xmus2)*SQRT(1-xmuv2)
                XPH2=XPH2*XFD*XBETA2*1.5
                XPH3=(1-xmus2)*(1-xmuv2)
                XPH3=XPH3*XFD*XBETA2*0.375
        endif

        ! Compute these quantities explicitly because frequently the
        ! calling routine will need them as well.
        exp1 = EXP(-XTAU/XMUV)
        exp2 = EXP(-XTAU/XMUS)

        XITM=(1-EXP(-XTAU*(1/XMUS+1/XMUV)))*XMUS/(4*(XMUS+XMUV))
        XP1=XPH1*XITM
        XP2=XPH2*XITM
        XP3=XPH3*XITM
        XITM=(1 - exp2)*(1 - exp1)
        CFONC1=XPH1*XITM
        CFONC2=XPH2*XITM
        CFONC3=XPH3*XITM
        XLNTAU=LOG(XTAU)

        PL(1)=1.0
        PL(2)=XLNTAU
        PL(3)=XMUS+XMUV
        PL(4)=XLNTAU*PL(3)
        PL(5)=XMUS*XMUV
        PL(6)=XLNTAU*PL(5)
        PL(7)=xmus2+xmuv2
        PL(8)=XLNTAU*PL(7)
        PL(9)=xmus2*xmuv2
        PL(10)=XLNTAU*PL(9)

        FS0=0.0
        DO 20 I=1, 10
                FS0=FS0+PL(I)*AS0(I)
20      continue
        FS1=PL(1)*AS1(1)+PL(2)*AS1(2)
        FS2=PL(1)*AS2(1)+PL(2)*AS2(2)
        XITOT1=XP1+CFONC1*FS0*XMUS
        XITOT2=XP2+CFONC2*FS1*XMUS
        XITOT3=XP3+CFONC3*FS2*XMUS
        XRRAY=XITOT1*XCOSF1
        XRRAY=XRRAY+XITOT2*XCOSF2*2
        XRRAY=XRRAY+XITOT3*XCOSF3*2
        XRRAY=XRRAY/XMUS
        RETURN
        END


        subroutine csalbr(xtau,xalb)
        implicit none
        real xtau,xalb
        real expint3
        xalb = (3*xtau-expint3(xtau)*(4+xtau+xtau)+2*exp(-xtau))
        xalb = xalb / (4.0+3*xtau)
        return
        end


C Evaluate exponential integral E3(x) for arguments in range [0,3].
C Accuracy of 1e-4
        real function expint3(x)
        implicit none
        real    x
        real    A0, A1, A2, A3, A4, A5, A6, A7
        parameter       (A0 = 0.4999258844, A1 = -0.9767510771,
     &                   A2 = 1.697941268, A3 = -3.584044765,
     &                   A4 = 6.398510396, A5 = -7.305407748,
     &                   A6 = 4.546504873, A7 = -1.167060981)
        expint3 = A0+(A1+(A2+(A3+(A4+(A5+(A6+A7*x)*x)*x)*x)*x)*x)*x
        return
        end


