#ifndef glbl_h
#define glbl_h
float32 ALPHAF, BETAF, GAMMAF, DELTAF, MIRAFTOG, MIRAFTIG, TATOG, TATIG, ROGT;
int AT_SCF;
#ifdef SUBSET
float32 T2M_value, NCEPH2O_value;
#endif
int SCFSTARTSCAN, SCFENDSCAN;
char *ProcessingEnvironment, *Platform; 
PGSt_double orbit_start_tai, orbit_end_tai;
int32 process_bands[BANDPROCESS];
commands_t commands;
input_metadata *metadata;
int32 locator500[NBSCANS_500M*NBSPOTS_500M];
int32 locator250[NBSCANS_250M*NBSPOTS_250M];  
int32 locator500_250[NBSCANS_250M*NBSPOTS_250M];  
float **Rho_ra_term, **Rho_r_term, **Step1_term, **Step2_term, **Step3_term, **SRA_term, **btau;
float **hkmRho_ra_term, **hkmRho_r_term, **hkmStep1_term, **hkmStep2_term, **hkmStep3_term, **hkmSRA_term;
float **qkmRho_ra_term, **qkmRho_r_term, **qkmStep1_term, **qkmStep2_term, **qkmStep3_term, **qkmSRA_term;
int n_bands_res[3]; /* 250m, 500m, 1km */
PGSt_MET_all_handles METAHANDLES; /* ECS metadata handles */
int32 dead_bands[BANDPROCESS][4 * NBSCANS_1KM];
int32 noisy_bands[BANDPROCESS][4 * NBSCANS_1KM];
int32 scans_per_gran;

/* For new look-up tables */
float32 tauray[NBANDS];
float32 oztransa[NBANDS];
float32 wvtransa[NBANDS],wvtransb[NBANDS],wvtransc[NBANDS];
float32 ogtransa0[NBANDS],ogtransa1[NBANDS];
float32 ogtransb0[NBANDS],ogtransb1[NBANDS];
float32 ogtransc0[NBANDS],ogtransc1[NBANDS];
float32 nbfi[NTS][NXX],tsmax[NTS][NXX],tsmin[NTS][NXX];
float32 ttv[NTS][NXX],nbfic[NTS][NXX];
float32 tts[NTS];
int indts[NTS];

/* 31-OCT-05: addition of several more LUTs */
float32 rolutt[NBANDS][NPR][NAOT][8000];
float32 transt[NBANDS][NPR][NAOT][NTS];
float32 sphalbt[NBANDS][NPR][NAOT];     /* just for now */

float32 roluttSMKL[NBANDS][NPR][NAOT][8000];
float32 transtSMKL[NBANDS][NPR][NAOT][NTS];
float32 sphalbtSMKL[NBANDS][NPR][NAOT];  

float32 roluttSMKH[NBANDS][NPR][NAOT][8000];
float32 transtSMKH[NBANDS][NPR][NAOT][NTS];
float32 sphalbtSMKH[NBANDS][NPR][NAOT];  

float32 roluttDUST[NBANDS][NPR][NAOT][8000];
float32 transtDUST[NBANDS][NPR][NAOT][NTS];
float32 sphalbtDUST[NBANDS][NPR][NAOT];  

float32 roluttURBPOL[NBANDS][NPR][NAOT][8000];
float32 transtURBPOL[NBANDS][NPR][NAOT][NTS];
float32 sphalbtURBPOL[NBANDS][NPR][NAOT];  

float32 roluttURBCLN[NBANDS][NPR][NAOT][8000];
float32 transtURBCLN[NBANDS][NPR][NAOT][NTS];
float32 sphalbtURBCLN[NBANDS][NPR][NAOT];  


/* 16-JUN-99: generic definitions */
#define OZZONE "OZ\0"
#define GOZZONE "GOZ\0"
#define SURFPR "SP\0"
#define WATERV "WV\0"
#define TEMPR  "TP\0"
#define UWND   "UW\0"
#define VWND   "VW\0"
  
char prefix[4];
char ESDTname[10];
char REF_ESDTname[10];
char CRF_ESDTname[10];
char VersionID[10];
int sat_type;
int we_have_ESDTname;


enum{WASNOTREAD, WASREAD};
d_ancillary daoozone;
d_ancillary gdasozone;
d_ancillary daospres;
d_ancillary daowv;
d_ancillary daotmp;
d_ancillary daouwnd;
d_ancillary daovwnd;
d_ancillary avg_z; 
int use_avg_z;

output_type_t output_type[ALLBANDS];
aerosol_retr_rej_t aotr_struct;

char sdsname[ALLBANDS-BANDPROCESS+1][50];

float32 *sref[7];  /* Simulated reflectance arrays.  Simulation is performed for 73 values of
	              relative azimuth phi ranging from 0 to 180, for 22 values of solar and
	              viewing zenith angles ranging from x to y, and for 10 values of aerosol
	              optical thickness. */
float32 *ta_tab[7];      /* transmission */
float32 Sra_tab[7][10];  /* surface albedo */

/* The following variables are for the IDS outputs.  */
d_sds **sds_outputlist;
int currentlyopen, current_n_CMGwindows,n_ret;
int make_this_cmg[3];
char CMG_lgid_template[256];
float leftlon;
input_metadata **CMGmetadata;
enum{NTHPL, MIDDLE, STHPL, NCMGFILES}; 
#define ULLAT 90.0000F
#define LRLAT -90.0000F
#define ULLON -180.0000F
#define LRLON 180.0000F 
#define POLELIM 60.0000F
#define NONPOLEWIDTH 90.0000F

int newl1bformat, l1b_needs_aggregation, band26corr;

#endif /* part of #ifndef/#define statements at beginning of file */
