#ifndef QAMAP_H
#define QAMAP_H
char QAMAP_1KM[2400] = 
                 {"\n\tBits are listed from the MSB (bit 31) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t31     adjacency correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t30     atmospheric correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t26-29  band 7 data quality four bit range;\n"
                  "\t       0000 -- highest quality\n"
                  "\t       1000 -- dead detector; data interpolated in L1B\n"
                  "\t       1001 -- solar zenith >= 86 degrees\n"
                  "\t       1010 -- solar zenith >= 85 and < 86 degrees\n"
                  "\t       1011 -- missing input\n"
                  "\t       1100 -- internal constant used in place of climatological data \n"
                  "\t               for at least one atmospheric constant\n"
                  "\t       1101 -- correction out of bounds pixel constrained to extreme \n"
                  "\t               allowable value\n"
                  "\t       1110 -- L1B data faulty\n"
                  "\t       1111 -- not processed due to deep ocean or clouds\n"
                  "\t22-25  band 6 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t18-21  band 5 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t14-17  band 4 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t10-13  band 3 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t6-9    band 2 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t2-5    band 1 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t0-1    MODLAND QA bits; \n"
                  "\t       corrected product produced at\n"
                  "\t       00 -- ideal quality all bands \n"
                  "\t       01 -- less than ideal quality some or all bands\n"
                  "\t       corrected product not produced due to\n"
                  "\t       10 -- cloud effects all bands \n"
                  "\t       11 -- other reasons some or all bands may be fill value\n"
                  "\t       [Note that a value of (11) overrides a value of (01)].\n\0"};

char QAMAP_250M[2200] = 
                 {"\n\tBits are listed from the MSB (bit 15) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t14-15  spare (unused); \n"
                  "\t13     adjacency correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t12     atmospheric correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t8-11   band 2 data quality four bit range;\n"
                  "\t       0000 -- highest quality\n"
                  "\t       1000 -- dead detector; data interpolated in L1B\n"
                  "\t       1001 -- solar zenith >= 86 degrees\n"
                  "\t       1010 -- solar zenith >= 85 and < 86 degrees\n"
                  "\t       1011 -- missing input\n"
                  "\t       1100 -- internal constant used in place of climatological data \n"
                  "\t               for at least one atmospheric constant\n"
                  "\t       1101 -- correction out of bounds pixel constrained to extreme \n"
                  "\t               allowable value\n"
                  "\t       1110 -- L1B data faulty\n"
                  "\t       1111 -- not processed due to deep ocean or clouds\n"
                  "\t4-7    band 1 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t2-3    cloud state;\n"
                  "\t       00 -- clear\n"
                  "\t       01 -- cloudy\n"
                  "\t       10 -- mixed\n"
                  "\t       11 -- not set, assumed clear\n"
                  "\t0-1    MODLAND QA bits; \n"
                  "\t       corrected product produced at\n"
                  "\t       00 -- ideal quality all bands \n"
                  "\t       01 -- less than ideal quality some or all bands\n"
                  "\t       corrected product not produced due to\n"
                  "\t       10 -- cloud effects all bands \n"
                  "\t       11 -- other reasons some or all bands may be fill value\n"
                  "\t       [Note that a value of (11) overrides a value of (01)].\n\0"};

char QAMAP_500M[2400] = 
                 {"\n\tBits are listed from the MSB (bit 31) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t31     adjacency correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t30     atmospheric correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t26-29  band 7 data quality four bit range;\n"
                  "\t       0000 -- highest quality\n"
                  "\t       1000 -- dead detector; data interpolated in L1B\n"
                  "\t       1001 -- solar zenith >= 86 degrees\n"
                  "\t       1010 -- solar zenith >= 85 and < 86 degrees\n"
                  "\t       1011 -- missing input\n"
                  "\t       1100 -- internal constant used in place of climatological data \n"
                  "\t               for at least one atmospheric constant\n"
                  "\t       1101 -- correction out of bounds pixel constrained to extreme \n"
                  "\t               allowable value\n"
                  "\t       1110 -- L1B data faulty\n"
                  "\t       1111 -- not processed due to deep ocean or clouds\n"
                  "\t22-25  band 6 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t18-21  band 5 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t14-17  band 4 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t10-13  band 3 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t6-9    band 2 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t2-5    band 1 data quality four bit range;\n"
                  "\t       SAME AS ABOVE\n"
                  "\t0-1    MODLAND QA bits; \n"
                  "\t       corrected product produced at\n"
                  "\t       00 -- ideal quality all bands \n"
                  "\t       01 -- less than ideal quality some or all bands\n"
                  "\t       corrected product not produced due to\n"
                  "\t       10 -- cloud effects all bands \n"
                  "\t       11 -- other reasons some or all bands may be fill value\n"
                  "\t       [Note that a value of (11) overrides a value of (01)].\n\0"};

char STATEQAMAP[2400] =  
                 {"\n\tBits are listed from the MSB (bit 15) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t15     internal snow algorithm flag; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t14     BRDF correction performed;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t13     Pixel is adjacent to cloud;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t12     MOD35 snow/ice flag;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t11     internal fire algorithm flag;\n"
                  "\t       1 -- fire\n"
                  "\t       0 -- no fire\n"
                  "\t10    internal cloud algorithm flag;\n"
                  "\t       1 -- cloud\n"
                  "\t       0 -- no cloud\n"
                  "\t8-9    cirrus detected;\n"
                  "\t       00 -- none\n"
                  "\t       01 -- small\n"
                  "\t       10 -- average\n"
                  "\t       11 -- high\n"
                  "\t6-7    aerosol quantity;\n"
                  "\t       00 -- climatology\n"
                  "\t       01 -- low\n"
                  "\t       10 -- average\n"
                  "\t       11 -- high\n"
                  "\t3-5    land/water flag;\n"
                  "\t       000 -- shallow ocean\n"
                  "\t       001 -- land\n"
                  "\t       010 -- ocean coastlines and lake shorelines\n"
                  "\t       011 -- shallow inland water\n"
                  "\t       100 -- ephemeral water\n"
                  "\t       101 -- deep inland water\n"
                  "\t       110 -- continental/moderate ocean\n"
                  "\t       111 -- deep ocean\n"
                  "\t2      cloud shadow;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t0-1    cloud state;\n"
                  "\t       00 -- clear\n"
                  "\t       01 -- cloudy\n"
                  "\t       10 -- mixed\n"
                  "\t       11 -- not set, assumed clear\n\0"};
		  
char STATEQAMAP_DELUXE[2600] =  
                 {"\n\tBits are listed from the MSB (bit 15) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t15     internal snow algorithm flag; \n"
                  "\t       1 -- yes, %.2f%%\n"
                  "\t       0 -- no, %.2f%%\n"
                  "\t14     BRDF correction performed;\n"
                  "\t       1 -- yes, %.2f%%\n"
                  "\t       0 -- no, %.2f%%\n"
                  "\t13     Pixel is adjacent to cloud;\n"
                  "\t       1 -- yes, %.2f%%\n"
                  "\t       0 -- no, %.2f%%\n"
                  "\t12     MOD35 snow/ice flag;\n"
                  "\t       1 -- yes, %.2f%%\n"
                  "\t       0 -- no, %.2f%%\n"
                  "\t11     internal fire algorithm flag;\n"
                  "\t       1 -- fire, %.2f%%\n"
                  "\t       0 -- no fire, %.2f%%\n"
                  "\t10     internal cloud algorithm flag;\n"
                  "\t       1 -- cloud, %.2f%%\n"
                  "\t       0 -- no cloud, %.2f%%\n"
                  "\t8-9    cirrus detected;\n"
                  "\t       00 -- none, %.2f%%\n"
                  "\t       01 -- small, %.2f%%\n"
                  "\t       10 -- average, %.2f%%\n"
                  "\t       11 -- high, %.2f%%\n"
                  "\t6-7    aerosol quantity;\n"
                  "\t       00 -- climatology, %.2f%%\n"
                  "\t       01 -- low, %.2f%%\n"
                  "\t       10 -- average, %.2f%%\n"
                  "\t       11 -- high, %.2f%%\n"
                  "\t3-5    land/water flag;\n"
                  "\t       000 -- shallow ocean, %.2f%%\n"
                  "\t       001 -- land, %.2f%%\n"
                  "\t       010 -- ocean coastlines and lake shorelines, %.2f%%\n"
                  "\t       011 -- shallow inland water, %.2f%%\n"
                  "\t       100 -- ephemeral water, %.2f%%\n"
                  "\t       101 -- deep inland water, %.2f%%\n"
                  "\t       110 -- continental/moderate ocean, %.2f%%\n"
                  "\t       111 -- deep ocean, %.2f%%\n"
                  "\t2      cloud shadow;\n"
                  "\t       1 -- yes, %.2f%%\n"
                  "\t       0 -- no, %.2f%%\n"
                  "\t0-1    cloud state;\n"
                  "\t       00 -- clear, %.2f%%\n"
                  "\t       01 -- cloudy, %.2f%%\n"
                  "\t       10 -- mixed, %.2f%%\n"
                  "\t       11 -- not set, assumed clear, %.2f%%\n\0"};

char QAMAP_COARSE[1200] = 
                 {"\n\tBits are listed from the MSB (bit 7) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t7      pixel flagged as containing fire; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t6      atmospheric correction performed; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t5      land/sea mask; \n"
                  "\t       1 -- land\n"
                  "\t       0 -- sea\n"
                  "\t4      input L1B is bad or missing for at least one band; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t3      high solar zenith (sz >= 85 and < 86 degrees); \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t2      pixel on terminator (sz >= 86 degrees); \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t0-1    cloud state;\n"
                  "\t       00 -- clear\n"
                  "\t       01 -- cloudy\n"
                  "\t       10 -- mixed\n"
                  "\t       11 -- not set, assumed clear\n\0"};

char QAMAP_INTCM[1700] = 
                 {"\n\tBits are listed from the MSB (bit 15) to the LSB (bit 0):\n"
                  "\tBit    Description\n"
                  "\t15     unused \n"
                  "\t14     AOT has climatological values;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
		  "\t13     criteria used for aerosol retrieval; \n"
                  "\t       1 -- criterion 2\n"
                  "\t       0 -- criterion 1\n"
                  "\t12     pan flag; \n"
                  "\t       1 -- salt pan\n"
                  "\t       0 -- no salt pan\n"
                  "\t10-11  cirrus; \n"
                  "\t       00 -- none\n"
                  "\t       01 -- small\n"
		  "\t       10 -- average\n"
		  "\t       11 -- high\n"
                  "\t9      pixel is adjacent to cloud;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t8      cloud shadow;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t7      dust; \n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t6      sun glint;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t5      fire;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t4      snow;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t3      low clouds;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t2      high clouds;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t1      clear;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n"
                  "\t0      cloudy;\n"
                  "\t       1 -- yes\n"
                  "\t       0 -- no\n\0"};

char QAMAP_AOTQA[1700] = 
                 {"\n\tNot bitmapped, but with the following values:\n"
                  "\t0      inital value;\n"
                  "\t1      None of the 500m pixels that correspond to this 1km pixel \n"
                  "\t         has data that reaches either criteria for containing aerosols;\n"
                  "\t2      Pixel is over water;\n"
                  "\t3      One or more of the retrieved aerosol values has saturated\n"
		  "\t         (and then all are set to a fill value);\n"
                  "\t4      Pixel is cloudy or mixed or has a high band 26 value;\n"
                  "\t5      Pixel had been flagged as water, but also had positive NDVI;\n"
                  "\t6      Pixel is flagged as water and tests clear;\n"
                  "\t7      Pixel is flagged as water and tests for turbidity;\n"
                  "\t8      Snow (set in aot_filter());\n"
                  "\t9      Bad geolocation, or high solar zenith;\n"
                  "\t10     Snow, or sunglint, or fire;\n"
                  "\t11     Bad 500m data, no aerosol retrieval;\n"
                  "\t12     Subpixel cloud (set in aot_filter());\n"
                  "\t13     Aerosol retrieval anomalies;\n"
                  "\t14     Possible salt-pan;\n"
                  "\t15     Desert;\n"
                  "\t16     Aerosol retrieval rejection (from global_AOTR_rejection_mask.hdf);\n"
		  "\t17     Anomalous atmospheric correction in 500m cloud test;\n"
		  "\t18     AOT set to zero in routine check_correction();\n"
		  "\t19     Adjacent to cloud;\n\0"};

char STATE_STATS_FOR_GLOBAL_METADATA[1200] =
             {"\n\tInternal snow mask:\t%d\n"
              "\tBRDF correction:\t%d\n"
              "\tAdjacent to cloud:\t%d\n"
              "\tMOD35 Snow or ice:\t%d\n"
              "\tInternal fire mask:\t%d\n"
              "\tInternal cloud mask:\t%d\n"
              "\tNo cirrus:\t%d\n"
              "\tSmall cirrus:\t%d\n"
              "\tAverage cirrus:\t%d\n"
              "\tHigh cirrus:\t%d\n"
              "\tAerosol quality, climatology:\t%d\n"
              "\tAerosol quality, low:\t%d\n"
              "\tAerosol quality, average:\t%d\n"
              "\tAerosol quality, high:\t%d\n"
              "\tShallow ocean:\t%d\n"
              "\tLand:\t%d\n"
              "\tCoastlines, shorelines:\t%d\n"
              "\tShallow inland water:\t%d\n"
              "\tEphemeral water:\t%d\n"
              "\tDeep inland water:\t%d\n"
              "\tContinental ocean:\t%d\n"
              "\tDeep ocean:\t%d\n"
              "\tCloud shadow:\t%d\n"
              "\tClear:\t%d\n"
              "\tCloudy:\t%d\n"
              "\tMixed (partly cloudy):\t%d\n"
              "\tCloud not set:\t%d\n\0"};

PGSt_PC_Logical luns[] = {209600,209601,209602,209900,209901,209902,209903,209904,
                          209905,209906,209907,209908,209909,209910,209911,209912,
                          209913,209914,209915,209916,209917,209918,209930,209931,
		          209932,209933,209934,209935,209936,209937,209938,209939,
		          209940};
char lun_description[][55] = {
            {"adja_on; 1=enable 0=disable\0"},
            {"brdf_mode; 0=none 1=Montana 2=Boston\0"},
            {"lam_cor; 0=disable 1=enable\0"},
            {"process 250m data band 1; 1=yes, 0 = no\0"},
            {"process 250m data band 2; 1=yes, 0 = no\0"},
            {"process 500m data band 1; 1=yes, 0 = no\0"},
            {"process 500m data band 2; 1=yes, 0 = no\0"},
            {"process 500m data band 3; 1=yes, 0 = no\0"},
            {"process 500m data band 4; 1=yes, 0 = no\0"},
            {"process 500m data band 5; 1=yes, 0 = no\0"},
            {"process 500m data band 6; 1=yes, 0 = no\0"},
            {"process 500m data band 7; 1=yes, 0 = no\0"},
            {"process 1km data band 1; 1=yes, 0 = no\0"},
            {"process 1km data band 2; 1=yes, 0 = no\0"},
            {"process 1km data band 3; 1=yes, 0 = no\0"},
            {"process 1km data band 4; 1=yes, 0 = no\0"},
            {"process 1km data band 5; 1=yes, 0 = no\0"},
            {"process 1km data band 6; 1=yes, 0 = no\0"},
            {"process 1km data band 7; 1=yes, 0 = no\0"},
            {"produce coarse resolution product; 1=yes, 0=no\0"},
            {"produce fire product; 1=yes, 0=no\0"},
            {"process sea pixels; 1=yes, 0=no\0"},
            {"scans to process; -1 = process all scans\0"},
            {"make cloud shadow 1=yes 0=no\0"},
            {"force internal cloud mask for reflectance 1=yes 0=no\0"},
            {"use MODIS AOT 0=no 1=yes\0"},
            {"mid-IR fire coefficient\0"},
            {"mid-IR fire power\0"},
            {"mid-IR fire threshold\0"},
            {"mid-IR fire threshold in glint\0"},
            {"thermal anomaly threshold\0"},
            {"thermal anomaly threshold in glint\0"},
            {"glint threshold\0"}
                           };
short n_luns = 33;
#endif
