/* @@ 016144909 /clear_vobs1/MODIS/STORE/PGE11/MOD_PR09/smfio.h /main/1 Jennifer Davis (STX) 08-Jan-98.12:51:43 @@ */
/* NODAAC may need to be defined when running this code
in any non-DAAC processing mode.  This feature was added
by MODIS SDST to ensure compliance with ESDIS standards upon
delivering this software to the DAAC. */

#ifdef NODAAC
#endif

#include "hdfi.h"

#ifndef smfio_h
#define smfio_h

/*****************************************************************************
!C-INC

!Description:

  Header file necessary for use with SSTG land team developed modules.

!Input Parameters:None

!Output Parameters:None
 
!Revision History:
 
Revision 2.0
P. Fisher/SSAI, NASA's GSFC Code 923
Updated to include new protpotypes for functions appearing within smf.c.

$Log: smfio.h,v $
Revision 1.3  1996/10/24 17:35:59  fisher
SDST baselined Version 1
Returned from SDST 10/23/96

Revision 1.10  1996/08/01 21:09:25  fisher
updated to conform to modis standards

 * Revision 1.9  1996/06/15  06:41:29  fisher
 * ,
 *
 * Revision 1.8  1996/06/07  18:27:57  fisher
 * *** empty log message ***
 *
 * Revision 1.7  1996/05/13  19:44:53  fisher
 * updated for concat_mpfn()
 *
 * Revision 1.6  1996/04/08  18:05:13  fisher
 * prologue revision
 *
 * Revision 1.5  1996/04/08  17:55:52  fisher
 * Added prototype for rmpath
 *
 * Revision 1.4  1996/04/03  00:14:08  fisher
 * Added prototype for current_time_a
 *
 * Revision 1.3  1996/03/08  20:21:50  fisher
 * Added memory definition for current_time_a (TIMECODEASIZE)
 *
 * Revision 1.2  1995/07/14  17:57:12  fisher
 * Prologue update
 *
 * Revision 1.1  1995/07/12  18:58:26  fisher
 * Initial revision
 *
$Id: smfio.h,v 1.3 1996/10/24 17:35:59 fisher Exp $

!Team-unique Header:
  This software has been created by the MODIS Science Data Support
  Team for the National Aeronautics and Space Administration,
  Goddard Space Flight Center, under contract NAS5-32373.

!References and Credits:

    Written by Paul S. Fisher
    Research and Data Systems Corporation
    SAIC/GSC MODIS Support Office
    7501 Forbes Blvd
    Seabrook MD 20706  

!Design Notes:

    This header file should be included in all relevant, integrated
    pieces of source code.



!END
*****************************************************************************/



/* SDP Toolkit I/O header file */
#include "PGS_IO.h"

/* SDP Toolkit Status Message Facility header file */
#include "PGS_SMF.h"

/* C time functions */
#include <time.h>

#define SMF_MAX_ACT_SIZE 80              /* this is supposed to be defined
                                            as PGSd_SMF_MAX_ACT_SIZE,
                                            according to the SDP Toolkit
                                            Primer, in the SDP Toolkit;
                                            until it is, we'll define
                                            it here */

#ifndef READ
#define READ   PGSd_IO_Gen_Read            /* Epro_read "r"*/
#endif

#ifndef WRITE
#define WRITE  PGSd_IO_Gen_Write           /* Epro_write, truncate, create "w"*/
#endif

#ifndef APPEND
#define APPEND PGSd_IO_Gen_Append          /* Epro_write/append, create "a"*/
#endif

#ifndef UPDATE
#define UPDATE PGSd_IO_Gen_Update          /* Epro_read/Epro_write "r+"*/
#endif

#ifndef TRUNC  
#define TRUNC  PGSd_IO_Gen_Trunc           /* Epro_read/Epro_write, truncate, create 
					      "w+" */
#endif

#ifndef APUP   
#define APUP   PGSd_IO_Gen_AppendUpdate    /* Epro_read whole file, Epro_write/append,
					      create "a+"*/
#endif

/* Prototypes */
void modsmf(PGSt_SMF_code mnemonicstring,
	    char *infostring,
	    char *functionstring);

PGSt_SMF_status modfileopen(PGSt_PC_Logical FilePCFIndex,
			    PGSt_IO_Gen_AccessType FileAccessFlag,
			    PGSt_IO_Gen_FileHandle **FilePtr,
			    PGSt_integer VersionNumber);

void gran_error_smf(PGSt_SMF_code mnemonicstring, char *infostring, char *functionstring,
		    PGSt_PC_Logical file_lun, int32 version, int32 orbitnumber, int32 granulenumber);

PGSt_SMF_status modfileclose(PGSt_PC_Logical FilePCFIndex,
			     PGSt_IO_Gen_FileHandle *FilePtr);

PGSt_SMF_status current_time_a(char *);

PGSt_SMF_status rmpath(char *);

PGSt_SMF_status concat_mpfn(char *mpfn, int32 mem, char *ins_name, 
			    char *vers, char *prod, char *level, 
			    char *start_time, 
			    char *proc_time, int32 classnum, ...);

/* definition for proper memory allocation of current_time_a() */

#define TIMECODEASIZE 28

/* #defines for concat_mpfn(); */

/* the following determine memory requirements (in bytes+1) for each 
   type of file name.  Each class type is set to 300, which is way more
   than needed, but since the nmemonics aren't stable let, this should 
   ensure that enough memory is allocated to hold the file name.*/

#define CLASSONE 300
#define CLASSTWO 300
#define CLASSTHREE 300
#define CLASSFOUR 300
#define TIMECODEBSIZE 27    /* to hold ASCII time code B strings */
#define SUBFILE 30 /* memory requirements +1 of the subfile string */
#define TNUMLENGTH 10 /* number of digits +1 in land tile specifiers */

/* opther naming convention definitions */
#define INSTRUMENT_AB "MOD"   /* instrument name abbreviation as a string*/
#define DATESIG 'D' /* Date signifier specified in the naming convention */


#endif /* part of #ifndef/#define statements at beginning of file */
